(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/forms'), require('@angular/common'), require('fast-equals')) :
    typeof define === 'function' && define.amd ? define('ngrx-clean-forms', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/forms', '@angular/common', 'fast-equals'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngrx-clean-forms'] = {}, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.forms, global.ng.common, global['fast-equals']));
}(this, (function (exports, i0, rxjs, operators, forms, common, fastEquals) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var CONFIG_TOKEN = new i0.InjectionToken('NGRX_CLEAN_FORMS_CONFIG');
    var defaultConfig = {
        throttleTime: 20,
        distinctWritesOnly: true,
    };
    var throttle = function (config) { return operators.throttleTime(config.throttleTime, rxjs.asyncScheduler, {
        leading: true,
        trailing: true,
    }); };

    function isFormArray(formArray) {
        return typeof formArray === 'object' && Array.isArray(formArray.controls);
    }
    function isFormGroup(formGroup) {
        return (typeof formGroup === 'object' &&
            formGroup.controls &&
            typeof formGroup.controls === 'object');
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    /**
     * Maps an object of control states to a value given by the `mapFunc`.
     *
     * @param controls Object which contains keys and associated control update.
     * @param mapFunc Mapper function to convert the update.
     *
     * @example
     * // Mapping of:
     * const controls = {
     *  firstControl: {
     *    value: 'firstValue',
     *    ...
     *  },
     *  secondControl: {
     *    value: 'secondValue',
     *    ...
     *  },
     * }
     *
     * // With the function:
     * const mapFunc = (control) => control.value
     *
     * // Will result in:
     * const result = {
     *  firstControl: 'firstValue',
     *  secondControl: 'secondValue'
     * }
     */
    function mapFormGroupControlStates(controls, mapFunc) {
        return mapFormControls(controls, mapFunc);
    }
    /**
     * Maps an object of control summaries to a value given by the `mapFunc`.
     *
     * @param controls Object which contains keys and associated control summaries.
     * @param mapFunc Mapper function to convert the update.
     *
     * @example
     * // Mapping of:
     * const controls = {
     *  firstControl: {
     *    value: 'firstValue',
     *    ...
     *  },
     *  secondControl: {
     *    value: 'secondValue',
     *    ...
     *  },
     * }
     *
     * // With the function:
     * const mapFunc = (control) => control.value
     *
     * // Will result in:
     * const result = {
     *  firstControl: 'firstValue',
     *  secondControl: 'secondValue'
     * }
     */
    function mapFormGroupControlSummaries(controls, mapFunc) {
        return mapFormControls(controls, mapFunc);
    }
    /**
     * Maps an object of control updates to a value given by the `mapFunc`.
     *
     * @param controls Object which contains keys and associated control updates.
     * @param mapFunc Mapper function to convert the update.
     *
     * @example
     * // Mapping of:
     * const controls = {
     *  firstControl: {
     *    value: 'firstValue',
     *    ...
     *  },
     *  secondControl: {
     *    value: 'secondValue',
     *    ...
     *  },
     * }
     *
     * // With the function:
     * const mapFunc = (control) => control.value
     *
     * // Will result in:
     * const result = {
     *  firstControl: 'firstValue',
     *  secondControl: 'secondValue'
     * }
     */
    function mapFormGroupControlUpdates(controls, mapFunc) {
        return mapFormControls(controls, mapFunc);
    }
    function mapFormControls(controls, mapFunc) {
        var result = Object.entries(controls)
            .map(function (_a) {
            var _b;
            var _c = __read(_a, 2), key = _c[0], control = _c[1];
            return (_b = {},
                _b[key] = mapFunc(control, key),
                _b);
        })
            .reduce(function (ctrl1, ctrl2) { return (Object.assign(Object.assign({}, ctrl1), ctrl2)); }, {});
        return result;
    }
    /**
     * Converts one or multiple Angular validators for the usage with this framework.
     * Does **not** support asynchronous validators.
     * Uses Validators.compose from @angular/forms.
     *
     * Only a subset of properties is available for the Angular validators:
     * `value, dirty, pristine, touched, untouched, enabled, disabled`
     * @param fn Angular validator function..
     */
    function validatorOf() {
        var fn = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            fn[_i] = arguments[_i];
        }
        var composed = forms.Validators.compose(fn);
        return function (control) { return composed({
            value: control.value,
            dirty: !control.pristine,
            pristine: control.pristine,
            touched: !control.untouched,
            untouched: control.untouched,
            enabled: !control.disabled,
            disabled: control.disabled,
        }); };
    }
    /**
     * Merges an array of `FormControlErrors`.
     * Returns null if all errors are null.
     * @param errors An array of `FormControlErrors` which will be merged into a single `FormControlErrors` value.
     */
    function mergeFormControlErrors() {
        var errors = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            errors[_i] = arguments[_i];
        }
        return errors.reduce(function (e1, e2) {
            if (!e1 && !e2) {
                return null;
            }
            if (!e1) {
                return e2;
            }
            if (!e2) {
                return e1;
            }
            return Object.assign(Object.assign({}, e1), e2);
        }, null);
    }
    /**
     * Merges an array of errors.
     * The different child control errors will also be merged.
     * Returns null if all errors are null.
     * @param errors Multiple errors to be merged.
     *
     * @example
     * // Merge of:
     * {
     *   stringControl: {
     *     firstError: 'firstError'
     *   }
     * },
     * {
     *   stringControl: {
     *     secondError: 'secondError'
     *   }
     * }
     *
     * // Will result in:
     * {
     *   stringControl: {
     *     firstError: 'firstError',
     *     secondError: 'secondError'
     *   }
     * }
     *
     */
    function mergeFormGroupErrors() {
        var errors = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            errors[_i] = arguments[_i];
        }
        return errors.reduce(function (group1, group2) {
            if (!group1 && !group2) {
                return null;
            }
            if (!group1) {
                return group2;
            }
            if (!group2) {
                return group1;
            }
            return Object.assign(Object.assign(Object.assign({}, group1), group2), Object.keys(group1)
                .filter(function (key1) { return Object.keys(group2).find(function (key2) { return key1 === key2; }); })
                .map(function (key) {
                var _a;
                return (_a = {},
                    _a[key] = mergeFormControlErrors(group1[key], group2[key]),
                    _a);
            })
                .reduce(function (e1, e2) { return (Object.assign(Object.assign({}, e1), e2)); }, {}));
        }, null);
    }
    /**
     * Merges an array of errors.
     * Errors at each index will also be merged.
     * Returns null if all errors are null.
     * @param errors Multiple errors to be merged.
     *
     * @example
     * // Merge of:
     * [
     *   {
     *     firstError: 'firstError'
     *   }
     * ],
     * [
     *   stringControl: {
     *     secondError: 'secondError'
     *   }
     * ]
     *
     * // Will result in:
     * [
     *   {
     *     firstError: 'firstError',
     *     secondError: 'secondError'
     *   }
     * ]
     *
     */
    function mergeFormArrayErrors() {
        var errors = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            errors[_i] = arguments[_i];
        }
        var mergedErrors = errors
            .filter(Boolean)
            .reduce(function (arr1, arr2) { return (arr1.length >= arr2.length ? arr1 : arr2); }, [])
            .map(function (_, i) { return mergeFormControlErrors.apply(void 0, __spreadArray([], __read(errors.map(function (arrayErrors) { return arrayErrors && arrayErrors[i]; })))); });
        return mergedErrors.filter(Boolean).length > 0 ? mergedErrors : null;
    }

    /**
     * Returns a `FormControlState` which represents the input state with the applied update.
     * The returned value is a new constructed object, except when the update is invalid.
     *
     * @param control The `FormControlState` which the update will be applied to.
     * @param update The `FormControlUpdate` itself.
     */
    function reduceFormControl(control, update) {
        if (!update) {
            return control;
        }
        return Object.assign(Object.assign({}, control), update);
    }
    /**
     * Returns a `FormGroupState` which represents the input state with the applied update.
     * The returned value is a new constructed object, except when the update is invalid.
     *
     * @param control The `FormGroupState` which the update will be applied to.
     * @param update The `FormGroupUpdate` itself.
     */
    function reduceFormGroup(group, update) {
        if (!update) {
            return group;
        }
        return Object.assign(Object.assign(Object.assign({}, group), update), { controls: Object.assign(Object.assign({}, group.controls), (update.controls
                ? mapFormGroupControlUpdates(update.controls, function (control, key) { return (Object.assign(Object.assign({}, group.controls[key]), control)); })
                : {})) });
    }
    /**
     * Returns a `FormArrayState` which represents the input state with the applied update.
     * The returned value is a new constructed object, except when the update is invalid.
     *
     * @param control The `FormArrayState` which the update will be applied to.
     * @param update The `FormArrayUpdate` itself. Invalid values and empty objects inside the `update.controls` array will be ignored.
     */
    function reduceFormArray(group, update) {
        if (!update) {
            return group;
        }
        return Object.assign(Object.assign(Object.assign({}, group), update), { controls: group.controls.map(function (control, index) { return update && update.controls ? reduceFormControl(control, update.controls[index]) : control; }) });
    }

    /**
     * Initializes a new `FormControlState`.
     * @see `FormControlInit`
     *
     * @example
     * initFormControl(['value', [validator]])
     * initFormControl({value: 'value', validators: [validator], disabled: true, ...})
     */
    function initFormControl(initial) {
        return Array.isArray(initial)
            ? initFormControlFromTuple(initial)
            : initFormControlFromUpdate(initial);
    }
    /**
     * Initializes a new `FormGroupState`.
     * @param controls An object containing control initializations.
     * @param validators An array of GroupValidators which will be used for additional error detection.
     * @see `FormGroupInit`, `GroupValidator`
     *
     * @example
     * initFormGroup({
     *  firstControl: ['firstValue', [validator]],
     *  secondControl: {value: 'value', validators: [validator], disabled: true, ...}
     * })
     */
    function initFormGroup(controls, validators) {
        if (validators === void 0) { validators = []; }
        return {
            controls: Object.entries(controls)
                .map(function (_a) {
                var _b;
                var _c = __read(_a, 2), key = _c[0], initial = _c[1];
                return (_b = {},
                    _b[key] = initFormControl(initial),
                    _b);
            })
                .reduce(function (ctrl1, ctrl2) { return (Object.assign(Object.assign({}, ctrl1), ctrl2)); }, {}),
            validators: validators,
        };
    }
    /**
     * Initializes a new `FormArrayState`.
     * @param controls An object containing control initializations.
     * @param validators An array of ArrayValidators which will be used for additional error detection.
     * @see `FormArrayInit`, `ArrayValidator`
     *
     * @example
     * initFormArray(
     *  [
     *      ['firstValue', [validator]],
     *      {value: 'value', validators: [validator], disabled: true, ...}
     *  ],
     *  [arrayValidator])
     */
    function initFormArray(initial, validators) {
        if (validators === void 0) { validators = []; }
        return {
            controls: initial.map(function (init) { return initFormControl(init); }),
            validators: validators,
        };
    }
    function initFormControlFromTuple(_a) {
        var _b = __read(_a, 3), value = _b[0], _c = _b[1], validators = _c === void 0 ? [] : _c, _d = _b[2], disabled = _d === void 0 ? false : _d;
        return initFormControlFromUpdate({ value: value, validators: validators, disabled: disabled });
    }
    function initFormControlFromUpdate(initialUpdate) {
        return reduceFormControl({
            value: undefined,
            initialValue: initialUpdate.value,
            pristine: true,
            untouched: true,
            disabled: false,
            validators: [],
        }, initialUpdate);
    }

    var cssClasses = {
        invalid: 'ng-invalid',
        valid: 'ng-valid',
        pristine: 'ng-pristine',
        dirty: 'ng-dirty',
        touched: 'ng-touched',
        untouched: 'ng-untouched',
        changed: 'ng-changed',
        initial: 'ng-initial',
    };
    var CONTROL_DIRECTIVE_SELECTOR = "ngrxFormControl";
    var AbstractControlDirective = /** @class */ (function () {
        function AbstractControlDirective(ref, r2, injectedConfig) {
            var _this = this;
            this.ref = ref;
            this.r2 = r2;
            this.injectedConfig = injectedConfig;
            this.controlUpdate = new i0.EventEmitter(true);
            this._controlSummary$ = new rxjs.Subject();
            this.controlSummary$ = this._controlSummary$.asObservable();
            this.touched$ = new rxjs.Subject();
            this.value$ = new rxjs.Subject();
            this.config$ = new rxjs.BehaviorSubject(this.injectedConfig);
            this.summarySubscription = new rxjs.Subscription();
            this.config$
                .pipe(operators.switchMap(function (config) { return rxjs.merge(_this.touched$.pipe(throttle(config)), _this.value$.pipe(throttle(config))); }))
                .subscribe(function (value) { return _this.controlUpdate.emit(value); });
        }
        Object.defineProperty(AbstractControlDirective.prototype, "setControlSummary", {
            set: function (controlSummary) {
                if (!controlSummary) {
                    return;
                }
                this.updateSummary(controlSummary);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "setConfig", {
            set: function (inputConfig) {
                var config = Object.assign(Object.assign({}, this.injectedConfig), inputConfig);
                this.config$.next(config);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "controlSummary", {
            get: function () {
                return this._controlSummary;
            },
            enumerable: false,
            configurable: true
        });
        AbstractControlDirective.prototype.isValueChanged = function (nextValue) {
            var disabled = !this.config$.value.distinctWritesOnly;
            var lastValue = this.getValue();
            return disabled || !fastEquals.circularDeepEqual(nextValue, lastValue);
        };
        AbstractControlDirective.prototype.emitTouched = function () {
            this.touched$.next({ untouched: false });
        };
        AbstractControlDirective.prototype.emitValue = function (value) {
            this.value$.next({ value: value, pristine: false });
        };
        AbstractControlDirective.prototype.updateSummary = function (summary) {
            this._controlSummary = summary;
            this._controlSummary$.next(summary);
            if (this.isValueChanged(summary.value)) {
                this.setValue(summary.value);
            }
            this.setDisabled(summary.disabled);
            this.chooseClass(cssClasses.invalid, cssClasses.valid, summary.valid);
            this.chooseClass(cssClasses.dirty, cssClasses.pristine, summary.pristine);
            this.chooseClass(cssClasses.touched, cssClasses.untouched, summary.untouched);
            this.chooseClass(cssClasses.initial, cssClasses.changed, summary.changed);
        };
        AbstractControlDirective.prototype.chooseClass = function (class1, class2, chooseSecond) {
            if (chooseSecond) {
                this.r2.addClass(this.ref.nativeElement, class2);
                this.r2.removeClass(this.ref.nativeElement, class1);
            }
            else {
                this.r2.addClass(this.ref.nativeElement, class1);
                this.r2.removeClass(this.ref.nativeElement, class2);
            }
        };
        AbstractControlDirective.prototype.ngOnDestroy = function () {
            this.summarySubscription.unsubscribe();
            this.config$.complete();
            this.touched$.complete();
            this.value$.complete();
            this._controlSummary$.complete();
        };
        return AbstractControlDirective;
    }());
    AbstractControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AbstractControlDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    AbstractControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: AbstractControlDirective, inputs: { controlKey: ["ngrxFormControl", "controlKey"], setControlSummary: ["controlSummary", "setControlSummary"], setConfig: ["controlConfig", "setConfig"] }, outputs: { controlUpdate: "controlUpdate" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AbstractControlDirective, decorators: [{
                type: i0.Directive
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }];
        }, propDecorators: { controlKey: [{
                    type: i0.Input,
                    args: [CONTROL_DIRECTIVE_SELECTOR]
                }], setControlSummary: [{
                    type: i0.Input,
                    args: ['controlSummary']
                }], setConfig: [{
                    type: i0.Input,
                    args: ['controlConfig']
                }], controlUpdate: [{
                    type: i0.Output
                }] } });

    var RangeInputControlDirective = /** @class */ (function (_super) {
        __extends(RangeInputControlDirective, _super);
        function RangeInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        RangeInputControlDirective.prototype.onInput = function () {
            this.emitValue(this.getValue());
        };
        RangeInputControlDirective.prototype.onBlur = function () {
            this.emitTouched();
        };
        RangeInputControlDirective.prototype.getValue = function () {
            var value = this.ref.nativeElement.value;
            return value === '' ? null : parseFloat(value);
        };
        RangeInputControlDirective.prototype.setValue = function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'value', value);
        };
        RangeInputControlDirective.prototype.setDisabled = function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        return RangeInputControlDirective;
    }(AbstractControlDirective));
    RangeInputControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: RangeInputControlDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    RangeInputControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: RangeInputControlDirective, selector: "input[type=\"range\"][ngrxFormControl]", host: { listeners: { "input": "onInput()", "blur": "onBlur()" } }, providers: [
            {
                provide: AbstractControlDirective,
                useExisting: RangeInputControlDirective,
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: RangeInputControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: "input[type=\"range\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                        providers: [
                            {
                                provide: AbstractControlDirective,
                                useExisting: RangeInputControlDirective,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }];
        }, propDecorators: { onInput: [{
                    type: i0.HostListener,
                    args: ['input']
                }], onBlur: [{
                    type: i0.HostListener,
                    args: ['blur']
                }] } });

    var RadioControlNotSupported = Error(
    // tslint:disable-next-line: max-line-length
    "Radio inputs are not yet supported. If you need to use one consider wrapping it in a Component which implements the ControlValueAccessor interface.");
    var RadioInputControlDirective = /** @class */ (function (_super) {
        __extends(RadioInputControlDirective, _super);
        function RadioInputControlDirective(ref, r2, config) {
            var _this = _super.call(this, ref, r2, config) || this;
            throw RadioControlNotSupported;
            return _this;
        }
        RadioInputControlDirective.prototype.setValue = function (value) { };
        RadioInputControlDirective.prototype.getValue = function () {
            return null;
        };
        return RadioInputControlDirective;
    }(AbstractControlDirective));
    RadioInputControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: RadioInputControlDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    RadioInputControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: RadioInputControlDirective, selector: "input[type=\"radio\"][ngrxFormControl]", providers: [
            {
                provide: AbstractControlDirective,
                useExisting: RadioInputControlDirective,
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: RadioInputControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: "input[type=\"radio\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                        providers: [
                            {
                                provide: AbstractControlDirective,
                                useExisting: RadioInputControlDirective,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }];
        } });

    var SelectControlNotSupported = Error(
    // tslint:disable-next-line: max-line-length
    "Select inputs are not yet supported. If you need to use one consider wrapping it in a Component which implements the ControlValueAccessor interface.");
    var SelectInputControlDirective = /** @class */ (function (_super) {
        __extends(SelectInputControlDirective, _super);
        function SelectInputControlDirective(ref, r2, config) {
            var _this = _super.call(this, ref, r2, config) || this;
            throw SelectControlNotSupported;
            return _this;
        }
        SelectInputControlDirective.prototype.setValue = function (value) { };
        SelectInputControlDirective.prototype.getValue = function () {
            return null;
        };
        return SelectInputControlDirective;
    }(AbstractControlDirective));
    SelectInputControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: SelectInputControlDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    SelectInputControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: SelectInputControlDirective, selector: "select[ngrxFormControl]", providers: [
            {
                provide: AbstractControlDirective,
                useExisting: SelectInputControlDirective,
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: SelectInputControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: "select[" + CONTROL_DIRECTIVE_SELECTOR + "]",
                        providers: [
                            {
                                provide: AbstractControlDirective,
                                useExisting: SelectInputControlDirective,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }];
        } });

    var NumberInputControlDirective = /** @class */ (function (_super) {
        __extends(NumberInputControlDirective, _super);
        function NumberInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        NumberInputControlDirective.prototype.onInput = function () {
            this.emitValue(this.getValue());
        };
        NumberInputControlDirective.prototype.onBlur = function () {
            this.emitTouched();
        };
        NumberInputControlDirective.prototype.getValue = function () {
            var value = this.ref.nativeElement.value;
            return value === '' ? null : parseFloat(value);
        };
        NumberInputControlDirective.prototype.setValue = function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'value', value === null ? '' : value);
        };
        NumberInputControlDirective.prototype.setDisabled = function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        return NumberInputControlDirective;
    }(AbstractControlDirective));
    NumberInputControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: NumberInputControlDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    NumberInputControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: NumberInputControlDirective, selector: "input[type=\"number\"][ngrxFormControl]", host: { listeners: { "input": "onInput()", "blur": "onBlur()" } }, providers: [
            {
                provide: AbstractControlDirective,
                useExisting: NumberInputControlDirective,
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: NumberInputControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: "input[type=\"number\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                        providers: [
                            {
                                provide: AbstractControlDirective,
                                useExisting: NumberInputControlDirective,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }];
        }, propDecorators: { onInput: [{
                    type: i0.HostListener,
                    args: ['input']
                }], onBlur: [{
                    type: i0.HostListener,
                    args: ['blur']
                }] } });

    var TextInputControlDirective = /** @class */ (function (_super) {
        __extends(TextInputControlDirective, _super);
        function TextInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        TextInputControlDirective.prototype.onInput = function () {
            this.emitValue(this.getValue());
        };
        TextInputControlDirective.prototype.onBlur = function () {
            this.emitTouched();
        };
        TextInputControlDirective.prototype.getValue = function () {
            return this.ref.nativeElement.value;
        };
        TextInputControlDirective.prototype.setValue = function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'value', value);
        };
        TextInputControlDirective.prototype.setDisabled = function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        return TextInputControlDirective;
    }(AbstractControlDirective));
    TextInputControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: TextInputControlDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    TextInputControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: TextInputControlDirective, selector: "input[type=\"text\"][ngrxFormControl],textarea[ngrxFormControl],input:not([type=\"checkbox\"]):not([type=\"number\"]):not([type=\"range\"]):not([type=\"radio\"])[ngrxFormControl]", host: { listeners: { "input": "onInput()", "blur": "onBlur()" } }, providers: [
            {
                provide: AbstractControlDirective,
                useExisting: TextInputControlDirective,
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: TextInputControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        // tslint:disable-next-line: max-line-length
                        selector: "input[type=\"text\"][" + CONTROL_DIRECTIVE_SELECTOR + "],textarea[" + CONTROL_DIRECTIVE_SELECTOR + "],input:not([type=\"checkbox\"]):not([type=\"number\"]):not([type=\"range\"]):not([type=\"radio\"])[" + CONTROL_DIRECTIVE_SELECTOR + "]",
                        providers: [
                            {
                                provide: AbstractControlDirective,
                                useExisting: TextInputControlDirective,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }];
        }, propDecorators: { onInput: [{
                    type: i0.HostListener,
                    args: ['input']
                }], onBlur: [{
                    type: i0.HostListener,
                    args: ['blur']
                }] } });

    var ValueAccessorConnectorDirective = /** @class */ (function (_super) {
        __extends(ValueAccessorConnectorDirective, _super);
        function ValueAccessorConnectorDirective(ref, r2, config, accessors) {
            var _this = _super.call(this, ref, r2, config) || this;
            _this.initAccessor(accessors);
            return _this;
        }
        ValueAccessorConnectorDirective.prototype.initAccessor = function (accessors) {
            var _this = this;
            if (!accessors || !accessors.length) {
                return;
            }
            this.accessor = accessors[0];
            this.accessor.registerOnChange(function (val) { return _super.prototype.emitValue.call(_this, val); });
            this.accessor.registerOnTouched(function () { return _super.prototype.emitTouched.call(_this); });
        };
        ValueAccessorConnectorDirective.prototype.getValue = function () {
            return this.lastValue;
        };
        ValueAccessorConnectorDirective.prototype.setValue = function (value) {
            if (!this.accessor) {
                return;
            }
            this.accessor.writeValue(value);
            this.lastValue = value;
        };
        ValueAccessorConnectorDirective.prototype.setDisabled = function (disabled) {
            if (this.accessor && this.accessor.setDisabledState) {
                this.accessor.setDisabledState(disabled);
            }
        };
        return ValueAccessorConnectorDirective;
    }(AbstractControlDirective));
    ValueAccessorConnectorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: ValueAccessorConnectorDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }, { token: forms.NG_VALUE_ACCESSOR, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    ValueAccessorConnectorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: ValueAccessorConnectorDirective, selector: "[ngrxFormControl]:not(input):not(textarea):not(select)", providers: [
            {
                provide: AbstractControlDirective,
                useExisting: ValueAccessorConnectorDirective,
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: ValueAccessorConnectorDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: "[" + CONTROL_DIRECTIVE_SELECTOR + "]:not(input):not(textarea):not(select)",
                        providers: [
                            {
                                provide: AbstractControlDirective,
                                useExisting: ValueAccessorConnectorDirective,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [forms.NG_VALUE_ACCESSOR]
                        }] }];
        } });

    var CheckboxInputControlDirective = /** @class */ (function (_super) {
        __extends(CheckboxInputControlDirective, _super);
        function CheckboxInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        CheckboxInputControlDirective.prototype.onInput = function () {
            this.emitValue(this.getValue());
        };
        CheckboxInputControlDirective.prototype.onBlur = function () {
            this.emitTouched();
        };
        CheckboxInputControlDirective.prototype.getValue = function () {
            return this.ref.nativeElement.checked;
        };
        CheckboxInputControlDirective.prototype.setValue = function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'checked', value);
        };
        CheckboxInputControlDirective.prototype.setDisabled = function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        return CheckboxInputControlDirective;
    }(AbstractControlDirective));
    CheckboxInputControlDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: CheckboxInputControlDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.Renderer2 }, { token: CONFIG_TOKEN }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    CheckboxInputControlDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: CheckboxInputControlDirective, selector: "input[type=\"checkbox\"][ngrxFormControl]", host: { listeners: { "input": "onInput()", "blur": "onBlur()" } }, providers: [
            {
                provide: AbstractControlDirective,
                useExisting: CheckboxInputControlDirective,
            },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: CheckboxInputControlDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: "input[type=\"checkbox\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                        providers: [
                            {
                                provide: AbstractControlDirective,
                                useExisting: CheckboxInputControlDirective,
                            },
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [CONFIG_TOKEN]
                        }] }];
        }, propDecorators: { onInput: [{
                    type: i0.HostListener,
                    args: ['input']
                }], onBlur: [{
                    type: i0.HostListener,
                    args: ['blur']
                }] } });

    var controlDirectives = [
        TextInputControlDirective,
        CheckboxInputControlDirective,
        NumberInputControlDirective,
        RadioInputControlDirective,
        RangeInputControlDirective,
        SelectInputControlDirective,
        ValueAccessorConnectorDirective,
    ];

    var ControlChildrenDirective = /** @class */ (function () {
        function ControlChildrenDirective() {
        }
        ControlChildrenDirective.prototype.getChildren = function () {
            return this.convertToObservable(this.abstractInputs);
        };
        ControlChildrenDirective.prototype.convertToObservable = function (query) {
            return query.changes.pipe(operators.map(function () { return query; }), operators.startWith(query), operators.map(function (list) { return list.toArray(); }));
        };
        return ControlChildrenDirective;
    }());
    ControlChildrenDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: ControlChildrenDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    ControlChildrenDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: ControlChildrenDirective, queries: [{ propertyName: "abstractInputs", predicate: AbstractControlDirective, descendants: true }], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: ControlChildrenDirective, decorators: [{
                type: i0.Directive
            }], propDecorators: { abstractInputs: [{
                    type: i0.ContentChildren,
                    args: [AbstractControlDirective, { descendants: true }]
                }] } });

    var UnkownControlError = function (controlKey) { return new Error("The control \"" + controlKey + "\" is not part of the form."); };
    var AbstractFormDirective = /** @class */ (function (_super) {
        __extends(AbstractFormDirective, _super);
        function AbstractFormDirective(cdr) {
            var _this = _super.call(this) || this;
            _this.cdr = cdr;
            _this.formUpdate = new i0.EventEmitter();
            _this.formSummary$ = new rxjs.ReplaySubject(1);
            return _this;
        }
        Object.defineProperty(AbstractFormDirective.prototype, "setFormSummary", {
            set: function (summary) {
                if (!summary) {
                    return;
                }
                this.formSummary$.next(summary);
            },
            enumerable: false,
            configurable: true
        });
        AbstractFormDirective.prototype.ngAfterViewInit = function () {
            var _this = this;
            var children$ = this.getChildren();
            children$
                .pipe(operators.map(function (children) { return children.map(function (child) { return child.controlUpdate.pipe(operators.map(function (update) { return [update, child.controlKey]; })); }); }), operators.switchMap(function (children) { return rxjs.merge.apply(void 0, __spreadArray([], __read(children))); }))
                .subscribe(function (_a) {
                var _b = __read(_a, 2), update = _b[0], key = _b[1];
                return _this.emitUpdate(update, key);
            });
            rxjs.combineLatest([children$, this.formSummary$]).subscribe(function (_a) {
                var _b = __read(_a, 2), children = _b[0], summary = _b[1];
                return _this.updateChildren(children, summary);
            });
        };
        AbstractFormDirective.prototype.ngOnDestroy = function () {
            this.formSummary$.complete();
        };
        AbstractFormDirective.prototype.updateChildren = function (children, summary, shouldRetry) {
            if (shouldRetry === void 0) { shouldRetry = true; }
            return __awaiter(this, void 0, void 0, function () {
                var safeChildren, unknownControl, updatedChildren;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            safeChildren = children.filter(Boolean);
                            unknownControl = safeChildren.find(function (child) { return summary.controls[child.controlKey] === undefined; });
                            if (unknownControl && !shouldRetry) {
                                throw UnkownControlError(unknownControl.controlKey);
                            }
                            if (!unknownControl) return [3 /*break*/, 2];
                            this.cdr.detectChanges();
                            return [4 /*yield*/, this.getChildren().pipe(operators.first()).toPromise()];
                        case 1:
                            updatedChildren = _a.sent();
                            return [2 /*return*/, this.updateChildren(updatedChildren, summary, false)];
                        case 2:
                            safeChildren.forEach(function (control) {
                                control.updateSummary(summary.controls[control.controlKey]);
                            });
                            return [2 /*return*/];
                    }
                });
            });
        };
        return AbstractFormDirective;
    }(ControlChildrenDirective));
    AbstractFormDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AbstractFormDirective, deps: [{ token: i0__namespace.ChangeDetectorRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    AbstractFormDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: AbstractFormDirective, inputs: { setFormSummary: ["formSummary", "setFormSummary"] }, outputs: { formUpdate: "formUpdate" }, usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: AbstractFormDirective, decorators: [{
                type: i0.Directive
            }], ctorParameters: function () { return [{ type: i0__namespace.ChangeDetectorRef }]; }, propDecorators: { setFormSummary: [{
                    type: i0.Input,
                    args: ['formSummary']
                }], formUpdate: [{
                    type: i0.Output
                }] } });

    var FormGroupDirective = /** @class */ (function (_super) {
        __extends(FormGroupDirective, _super);
        function FormGroupDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FormGroupDirective.prototype.emitUpdate = function (update, key) {
            var _a;
            this.formUpdate.next({ controls: (_a = {}, _a[key] = update, _a) });
        };
        return FormGroupDirective;
    }(AbstractFormDirective));
    FormGroupDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: FormGroupDirective, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    FormGroupDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: FormGroupDirective, selector: "[ngrxFormGroup]", usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: FormGroupDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngrxFormGroup]',
                    }]
            }] });

    var FormArrayDirective = /** @class */ (function (_super) {
        __extends(FormArrayDirective, _super);
        function FormArrayDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        FormArrayDirective.prototype.emitUpdate = function (update, key) {
            var index = parseInt(key.toString(), 10);
            var controls = new Array(index + 1);
            controls[index] = update;
            this.formUpdate.next({ controls: controls });
        };
        return FormArrayDirective;
    }(AbstractFormDirective));
    FormArrayDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: FormArrayDirective, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    FormArrayDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: FormArrayDirective, selector: "[ngrxFormArray]", usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: FormArrayDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngrxFormArray]',
                    }]
            }] });

    /**
     * This module represents the entry point of ngrx-clean-forms.
     * It provides all necessary directives for the usage inside templates.
     *
     * The `.withConfig()` method can be used to pass a config to the module.
     *
     * - [npm](https://www.npmjs.com/package/ngrx-clean-forms)
     * - [documentation](https://github.com/NiklasPor/ngrx-clean-forms)
     */
    var NgrxCleanFormsModule = /** @class */ (function () {
        function NgrxCleanFormsModule() {
        }
        /**
         * Creates a new module with the given config. Missing values will be set with default values.
         *
         * @param config A partial `FormsConfig` object, supplying config paramters.
         *
         * @example
         * NgrxCleanFormsModule.withConfig({
         *   throttleTime: 15,
         * }),
         *
         */
        NgrxCleanFormsModule.withConfig = function (config) {
            return {
                ngModule: NgrxCleanFormsModule,
                providers: [
                    {
                        provide: CONFIG_TOKEN,
                        useValue: Object.assign(Object.assign({}, defaultConfig), config),
                    },
                ],
            };
        };
        return NgrxCleanFormsModule;
    }());
    NgrxCleanFormsModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: NgrxCleanFormsModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgrxCleanFormsModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: NgrxCleanFormsModule, declarations: [FormGroupDirective, FormArrayDirective, TextInputControlDirective, CheckboxInputControlDirective, NumberInputControlDirective, RadioInputControlDirective, RangeInputControlDirective, SelectInputControlDirective, ValueAccessorConnectorDirective], imports: [common.CommonModule], exports: [FormGroupDirective, FormArrayDirective, TextInputControlDirective, CheckboxInputControlDirective, NumberInputControlDirective, RadioInputControlDirective, RangeInputControlDirective, SelectInputControlDirective, ValueAccessorConnectorDirective] });
    NgrxCleanFormsModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: NgrxCleanFormsModule, providers: [
            {
                provide: CONFIG_TOKEN,
                useValue: defaultConfig,
            },
        ], imports: [[common.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0__namespace, type: NgrxCleanFormsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: __spreadArray([FormGroupDirective, FormArrayDirective], __read(controlDirectives)),
                        imports: [common.CommonModule],
                        exports: __spreadArray([FormGroupDirective, FormArrayDirective], __read(controlDirectives)),
                        providers: [
                            {
                                provide: CONFIG_TOKEN,
                                useValue: defaultConfig,
                            },
                        ],
                    }]
            }] });

    /**
     * Resets a control back to the default values.
     * The following values will be ignored and stay the same:
     * - `initialValue`
     * - `validators`
     * - `disabled`
     *
     * @param control The `FormControlState` which should be used to create the reset.
     * @param initialValue Optional parameter for passing a new initial value.
     */
    function resetFormControl(control, initialValue) {
        if (initialValue === void 0) { initialValue = control.initialValue; }
        return initFormControl([initialValue, control.validators, control.disabled]);
    }
    /**
     * Resets a group back to its default values.
     * Internally calls `resetFormControl` for every control.
     *
     * @see `resetFormControl`
     *
     * @param group The `FormGroupState` which should be used to create the reset.
     */
    function resetFormGroup(group) {
        var controls = mapFormGroupControlStates(group.controls, function (control) { return resetFormControl(control); });
        return reduceFormGroup(group, { controls: controls });
    }
    /**
     * Resets an array back to its default values.
     * Internally calls `resetFormControl` for every control.
     *
     * @see `resetFormControl`
     *
     * @param array The `FormArrayState` which should be used to create the reset.
     */
    function resetFormArray(array) {
        var controls = array.controls.map(function (control) { return resetFormControl(control); });
        return reduceFormArray(array, { controls: controls });
    }

    function getFormControlErrors(control) {
        return control.validators.map(function (validator) { return validator(control); });
    }
    function getFormGroupControlSummariesErrors(summaries) {
        var errors = mapFormGroupControlSummaries(summaries, function (summary) { return summary.errors; });
        Object.entries(errors)
            .filter(function (_a) {
            var _b = __read(_a, 2), _ = _b[0], value = _b[1];
            return value === null;
        })
            .forEach(function (_a) {
            var _b = __read(_a, 2), key = _b[0], _ = _b[1];
            return delete errors[key];
        });
        return Object.keys(errors).length ? errors : null;
    }
    function getFormArrayControlSummariesErrors(summaries) {
        var errors = summaries.map(function (summary) { return summary.errors; });
        return errors.filter(Boolean).length ? errors : null;
    }
    function getFormGroupErrors(group) {
        return mergeFormGroupErrors.apply(void 0, __spreadArray([], __read(group.validators.map(function (validator) { return validator(group); }))));
    }
    function getFormArrayErrors(array) {
        return mergeFormArrayErrors.apply(void 0, __spreadArray([], __read(array.validators.map(function (validator) { return validator(array); }))));
    }
    function getFormControlChanged(control) {
        return !fastEquals.circularDeepEqual(control.value, control.initialValue);
    }
    /**
     * Creates a `FormControlSummary` from the given `FormControlState`.
     * It is possible to add additional errors.
     *
     * @param control The `FormControlState` which is used to create the `FormControlSummary`.
     * @param additionalErrors An array of `FormControlErrors` which will be merged into the errors of the control.
     */
    function getFormControlSummary(control) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        var errors = mergeFormControlErrors.apply(void 0, __spreadArray(__spreadArray([], __read(getFormControlErrors(control))), __read(additionalErrors)));
        return Object.assign(Object.assign({}, control), { errors: errors, valid: errors === null, changed: getFormControlChanged(control) });
    }
    function getFormGroupControlSummaries(controls) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        var additionalError = mergeFormGroupErrors.apply(void 0, __spreadArray([], __read(additionalErrors)));
        return mapFormGroupControlStates(controls, function (control, key) { return getFormControlSummary(control, additionalError ? additionalError[key] : null); });
    }
    function getFormArrayControlSummaries(controls) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        var additionalError = mergeFormArrayErrors.apply(void 0, __spreadArray([], __read(additionalErrors)));
        return controls.map(function (control, i) { return getFormControlSummary(control, additionalError ? additionalError[i] : null); });
    }
    function getFormGroupPristine(group) {
        return Object.values(group.controls).every(function (control) { return control.pristine; });
    }
    function getFormArrayPristine(array) {
        return array.controls.every(function (control) { return control.pristine; });
    }
    function getFormGroupUntouched(group) {
        return Object.values(group.controls).every(function (control) { return control.untouched; });
    }
    function getFormGroupChanged(controls) {
        return Object.values(controls).some(function (control) { return control.changed; });
    }
    function getFormArrayChanged(controls) {
        return controls.some(function (control) { return control.changed; });
    }
    function getFormArrayUntouched(array) {
        return array.controls.every(function (control) { return control.untouched; });
    }
    function getFormArrayKeys(array) {
        return array.controls.map(function (_, i) { return i; });
    }
    /**
     * Creates a `FormGroupSummary` from the given `FormGroupState`.
     * It is possible to add additional errors.
     *
     * @param group The input `FormGroupState`. Used to create the `FormGroupSummary`.
     * @param additionalErrors An array of additional `FormGroupErrors`, which will be merged into the errors of the group and of each control.
     */
    function getFormGroupSummary(group) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        var groupErrors = getFormGroupErrors(group);
        var summaries = getFormGroupControlSummaries.apply(void 0, __spreadArray([group.controls, groupErrors], __read(additionalErrors)));
        var errors = getFormGroupControlSummariesErrors(summaries);
        return {
            controls: summaries,
            pristine: getFormGroupPristine(group),
            untouched: getFormGroupUntouched(group),
            errors: errors,
            valid: errors === null,
            changed: getFormGroupChanged(summaries),
            validators: group.validators,
        };
    }
    /**
     * Creates a `FormArraySummary` from the given `FormArrayState`.
     * It is possible to add additional errors.
     *
     * @param array The input `FormArrayState`. Used to create the `FormArraySummary`.
     * @param additionalErrors An array of additional `FormArrayErrors`, which will be merged into the errors of the array and of each control.
     */
    function getFormArraySummary(array) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        var arrayErrors = getFormArrayErrors(array);
        var summaries = getFormArrayControlSummaries.apply(void 0, __spreadArray([array.controls, arrayErrors], __read(additionalErrors)));
        var errors = getFormArrayControlSummariesErrors(summaries);
        return {
            controls: summaries,
            keys: getFormArrayKeys(array),
            pristine: getFormArrayPristine(array),
            untouched: getFormArrayUntouched(array),
            errors: errors,
            valid: errors === null,
            changed: getFormArrayChanged(summaries),
            validators: array.validators,
        };
    }

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AbstractControlDirective = AbstractControlDirective;
    exports.AbstractFormDirective = AbstractFormDirective;
    exports.CONFIG_TOKEN = CONFIG_TOKEN;
    exports.CONTROL_DIRECTIVE_SELECTOR = CONTROL_DIRECTIVE_SELECTOR;
    exports.CheckboxInputControlDirective = CheckboxInputControlDirective;
    exports.ControlChildrenDirective = ControlChildrenDirective;
    exports.FormArrayDirective = FormArrayDirective;
    exports.FormGroupDirective = FormGroupDirective;
    exports.NgrxCleanFormsModule = NgrxCleanFormsModule;
    exports.NumberInputControlDirective = NumberInputControlDirective;
    exports.RadioControlNotSupported = RadioControlNotSupported;
    exports.RadioInputControlDirective = RadioInputControlDirective;
    exports.RangeInputControlDirective = RangeInputControlDirective;
    exports.SelectControlNotSupported = SelectControlNotSupported;
    exports.SelectInputControlDirective = SelectInputControlDirective;
    exports.TextInputControlDirective = TextInputControlDirective;
    exports.UnkownControlError = UnkownControlError;
    exports.ValueAccessorConnectorDirective = ValueAccessorConnectorDirective;
    exports.controlDirectives = controlDirectives;
    exports.defaultConfig = defaultConfig;
    exports.getFormArrayChanged = getFormArrayChanged;
    exports.getFormArrayControlSummaries = getFormArrayControlSummaries;
    exports.getFormArrayControlSummariesErrors = getFormArrayControlSummariesErrors;
    exports.getFormArrayErrors = getFormArrayErrors;
    exports.getFormArrayKeys = getFormArrayKeys;
    exports.getFormArrayPristine = getFormArrayPristine;
    exports.getFormArraySummary = getFormArraySummary;
    exports.getFormArrayUntouched = getFormArrayUntouched;
    exports.getFormControlChanged = getFormControlChanged;
    exports.getFormControlErrors = getFormControlErrors;
    exports.getFormControlSummary = getFormControlSummary;
    exports.getFormGroupChanged = getFormGroupChanged;
    exports.getFormGroupControlSummaries = getFormGroupControlSummaries;
    exports.getFormGroupControlSummariesErrors = getFormGroupControlSummariesErrors;
    exports.getFormGroupErrors = getFormGroupErrors;
    exports.getFormGroupPristine = getFormGroupPristine;
    exports.getFormGroupSummary = getFormGroupSummary;
    exports.getFormGroupUntouched = getFormGroupUntouched;
    exports.initFormArray = initFormArray;
    exports.initFormControl = initFormControl;
    exports.initFormGroup = initFormGroup;
    exports.isFormArray = isFormArray;
    exports.isFormGroup = isFormGroup;
    exports.mapFormControls = mapFormControls;
    exports.mapFormGroupControlStates = mapFormGroupControlStates;
    exports.mapFormGroupControlSummaries = mapFormGroupControlSummaries;
    exports.mapFormGroupControlUpdates = mapFormGroupControlUpdates;
    exports.mergeFormArrayErrors = mergeFormArrayErrors;
    exports.mergeFormControlErrors = mergeFormControlErrors;
    exports.mergeFormGroupErrors = mergeFormGroupErrors;
    exports.reduceFormArray = reduceFormArray;
    exports.reduceFormControl = reduceFormControl;
    exports.reduceFormGroup = reduceFormGroup;
    exports.resetFormArray = resetFormArray;
    exports.resetFormControl = resetFormControl;
    exports.resetFormGroup = resetFormGroup;
    exports.throttle = throttle;
    exports.validatorOf = validatorOf;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngrx-clean-forms.umd.js.map
