import { ElementRef, EventEmitter, OnDestroy, Renderer2 } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { FormControlSummary, FormControlUpdate, FormsConfig } from '../../types';
import * as i0 from "@angular/core";
export declare const CONTROL_DIRECTIVE_SELECTOR = "ngrxFormControl";
export declare abstract class AbstractControlDirective<T = any> implements OnDestroy {
    protected ref: ElementRef;
    protected r2: Renderer2;
    private injectedConfig;
    controlKey?: string;
    set setControlSummary(controlSummary: FormControlSummary<T>);
    set setConfig(inputConfig: Partial<FormsConfig>);
    controlUpdate: EventEmitter<FormControlUpdate<T>>;
    get controlSummary(): FormControlSummary<T>;
    private _controlSummary$;
    readonly controlSummary$: Observable<FormControlSummary<T>>;
    private _controlSummary;
    constructor(ref: ElementRef, r2: Renderer2, injectedConfig: FormsConfig);
    private touched$;
    private value$;
    protected config$: BehaviorSubject<FormsConfig>;
    private summarySubscription;
    abstract setValue(value: T): any;
    abstract getValue(): T;
    isValueChanged(nextValue: T): boolean;
    setDisabled?(disabled: boolean): any;
    emitTouched(): void;
    emitValue(value: T): void;
    updateSummary(summary: FormControlSummary<T>): void;
    chooseClass(class1: string, class2: string, chooseSecond: boolean): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbstractControlDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AbstractControlDirective<any>, never, never, { "controlKey": "ngrxFormControl"; "setControlSummary": "controlSummary"; "setConfig": "controlConfig"; }, { "controlUpdate": "controlUpdate"; }, never>;
}
