import { AfterViewInit, EventEmitter, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { ReplaySubject } from 'rxjs';
import { FormArraySummary, FormArrayUpdate, FormControlUpdate, FormGroupSummary, FormGroupUpdate } from '../../types';
import { AbstractControlDirective } from '../controls/abstract-control.directive';
import { ControlChildrenDirective } from './control-children';
import * as i0 from "@angular/core";
export declare const UnkownControlError: (controlKey: any) => Error;
declare type FormSummary = FormGroupSummary<any> | FormArraySummary<any>;
declare type FormUpdate = FormGroupUpdate<any> | FormArrayUpdate<any>;
export declare abstract class AbstractFormDirective<Summary extends FormSummary, Update extends FormUpdate> extends ControlChildrenDirective implements AfterViewInit, OnDestroy {
    private cdr;
    set setFormSummary(summary: Summary);
    formUpdate: EventEmitter<Update>;
    constructor(cdr: ChangeDetectorRef);
    formSummary$: ReplaySubject<FormSummary>;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    updateChildren(children: AbstractControlDirective<any>[], summary: FormSummary, shouldRetry?: boolean): Promise<any>;
    abstract emitUpdate(update: FormControlUpdate<any>, key: string): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbstractFormDirective<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AbstractFormDirective<any, any>, never, never, { "setFormSummary": "formSummary"; }, { "formUpdate": "formUpdate"; }, never>;
}
export {};
