import { ModuleWithProviders } from '@angular/core';
import { FormsConfig } from './types';
import * as i0 from "@angular/core";
import * as i1 from "./directives/group/form-group.directive";
import * as i2 from "./directives/group/form-array.directive";
import * as i3 from "./directives/controls/text-input-control.directive";
import * as i4 from "./directives/controls/checkbox-input-control.directive";
import * as i5 from "./directives/controls/number-input-control.directive";
import * as i6 from "./directives/controls/radio-input-control.directive";
import * as i7 from "./directives/controls/range-input-control.directive";
import * as i8 from "./directives/controls/select-input-control.directive";
import * as i9 from "./directives/controls/value-accessor-connector.directive";
import * as i10 from "@angular/common";
/**
 * This module represents the entry point of ngrx-clean-forms.
 * It provides all necessary directives for the usage inside templates.
 *
 * The `.withConfig()` method can be used to pass a config to the module.
 *
 * - [npm](https://www.npmjs.com/package/ngrx-clean-forms)
 * - [documentation](https://github.com/NiklasPor/ngrx-clean-forms)
 */
export declare class NgrxCleanFormsModule {
    /**
     * Creates a new module with the given config. Missing values will be set with default values.
     *
     * @param config A partial `FormsConfig` object, supplying config paramters.
     *
     * @example
     * NgrxCleanFormsModule.withConfig({
     *   throttleTime: 15,
     * }),
     *
     */
    static withConfig(config: Partial<FormsConfig>): ModuleWithProviders<NgrxCleanFormsModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgrxCleanFormsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgrxCleanFormsModule, [typeof i1.FormGroupDirective, typeof i2.FormArrayDirective, typeof i3.TextInputControlDirective, typeof i4.CheckboxInputControlDirective, typeof i5.NumberInputControlDirective, typeof i6.RadioInputControlDirective, typeof i7.RangeInputControlDirective, typeof i8.SelectInputControlDirective, typeof i9.ValueAccessorConnectorDirective], [typeof i10.CommonModule], [typeof i1.FormGroupDirective, typeof i2.FormArrayDirective, typeof i3.TextInputControlDirective, typeof i4.CheckboxInputControlDirective, typeof i5.NumberInputControlDirective, typeof i6.RadioInputControlDirective, typeof i7.RangeInputControlDirective, typeof i8.SelectInputControlDirective, typeof i9.ValueAccessorConnectorDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgrxCleanFormsModule>;
}
